/*---------------------------------------------------------------------*/ 
/*  This is a Go board program.....                                    */
/*      sorry but this needs a 3 button mouse                          */
/*---------------------------------------------------------------------*/
/*                    Jim Morey  -  March 13, 1995                     */
/*                         morey@math.ubc.ca                           */
/*---------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include "app_glob.c"

#define TT              3.141592653589793
#define DtoR		TT/180

#define SCRBOR		20
#define ROTVEL          5
#define RETVEL		0.005
#define MOUMULT		1

#define MX_GRID    	5
#define DEPTH      	250
#define DCOL 		12
#define D4COL 		10
#define MAXCOLOURS      DCOL*D4COL + 3 
#define PTRS       	7
#define MAXPT  		(2*MX_GRID+1)*(2*MX_GRID+1)*(2*MX_GRID+1)*(2*MX_GRID+1)
#define MAXCON		MAXPT*2

#define NUSED      	-1
#define BLANK           0
#define EMPTY      	1
#define BL         	2
#define WH         	3

#define TETRA		0
#define SQUARE		1
#define HYPERSQ		2
#define HYPERTETRA	3
#define HYPERTETSQ	4
#define NUMBOARD	5

#define BLANK_COL	0
#define BL_COL	 	1
#define WH_COL	 	2

/* .. modes .. */
#define N_MODES         2
#define ROTATE 	 	0
#define CHOOSE 	 	1

/*----------------------------------------------------------------------*/

int depthcol[D4COL][DCOL]; 
unsigned long newpixel[MAXCOLOURS];
GC newGC[MAXCOLOURS];

void initapp(int, char **, int, int, unsigned, unsigned) ;
void ass_color();
      
/*----------------------------------------------------------------------*/

typedef float matrix[4][4];
typedef struct{
  int stat, scrcoord[4];
  float coord[4];
} vertex;
typedef struct{
  int def, pt;
} pointer;
typedef struct{
  int numedge;
  int numpt;
  vertex pt[MAXPT];
  int con[MAXCON][2];
} ob;

void    make_board();
void    make_colourmap();
void    ass_colour();
int     next_mat();

ob      board;
pointer ptr;
int     size,lengt=1000;
float   scale,blocksize;

/*---------------------------------------------------------------------*/
/*  .. Main ..                                                         */
/*---------------------------------------------------------------------*/

main(argc,argv)
int argc;
char **argv;
{
  int     i,j,k,l,draw,notdone,drawptr,min,try,style,create_board;
  int     moux,mouy,xp,yp,xpo,ypo,rot1,rot2,dimen,a11,a12,a21,a22,mode;
  int     number_colors;
  float   scale;
  matrix  tranm, goodtran,tran1,tran2,tempm;
  unsigned int maskr,oldmaskr;
  Window  junkrr,junkcr;
  char *app_options[] = {"-size","-message"};
  char *mode_head[]={
    "ROTATE -- (L xy/yz) (M xw/yw) (M+L zw/yw) (R CHOOSE)",
    "CHOOSE -- (L green) (M red) (R ROTATE)",
  }; 
  char *list[2];
  XTextProperty xmode_text[20][20];
  int num_options;
  XEvent win_event;

  for (i=0;i<N_MODES;i++){
    list[0] = mode_head[i];
    XStringListToTextProperty(list,1,xmode_text[i]);
  }

  num_options = sizeof(app_options)/sizeof(char *);

  for (i=1;i<argc;i++)
    for(j=0;j<num_options;j++)
      if(strcmp(app_options[j],argv[i])==0)
        switch (j){
          case 0:
            sscanf(argv[i+1],"%d",&lengt);
            i++;
          break;
          case 1:
            system("xmessage -title 'Go 4 it' -file info &");
          break;
        }

  size = 1;
  style = TETRA;
  mode = CHOOSE;

  /* .. set the two orientations to Identity and start there ..*/
  for (i=0;i<4;i++)
    for (j=0;j<4;j++)
      if (i==j) tranm[i][j] = 1.0;
      else tranm[i][j] = 0.0;

  equal_mat(tran1,tranm); 
  equal_mat(tran2,tranm); 

  /* ** create main window with title argv[0] ** */
  initapp(argc, argv, 0, 0, lengt, lengt);

  make_colourmap();
  XSetWMName(theDisplay, theMain, xmode_text[mode]);

  /* .. start big interface loop .. */
  XQueryPointer(theDisplay, theMain,&junkrr,&junkcr,
    &moux,&mouy,&xp,&yp,&maskr);
  xpo = xp;
  ypo = yp;
  create_board = 1;
  oldmaskr = 0;
  
  while (!(maskr & Mod1Mask) && !((maskr & Button1Mask)&&
         (maskr & Button2Mask)&& (maskr & Button3Mask))){
    drawptr=0;

    switch (mode){
      /*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/ 
      case CHOOSE :
        /* find the closest vertex to the pointer (top level closer) */ 
        if (!ptr.def || yp!=ypo || xp != xpo){
          j=ptr.pt;
          min = (board.pt[j].scrcoord[0]-xp)*(board.pt[j].scrcoord[0]-xp) + 
                  (board.pt[j].scrcoord[1]-yp)*(board.pt[j].scrcoord[1]-yp); 
          for (i=0;i<board.numpt;i++){
            try = (board.pt[i].scrcoord[0]-xp)*(board.pt[i].scrcoord[0]-xp) + 
                  (board.pt[i].scrcoord[1]-yp)*(board.pt[i].scrcoord[1]-yp); 
            if (board.pt[i].scrcoord[2]>board.pt[ptr.pt].scrcoord[2]&&try==min||
                try<min){
              min = try;
              ptr.def = 1;
              ptr.pt = i;
            }
          }  
            
          if (ptr.def) 
            if (ptr.pt != j){  /* .. don't draw unless something changes .. */
              draw = 1;
            }
        }
  
        if (oldmaskr != maskr){
          if (maskr & Button1Mask){   
            if (ptr.def){
              if (board.pt[ptr.pt].stat==EMPTY) 
                board.pt[ptr.pt].stat=BL;
              else if (board.pt[ptr.pt].stat==BL) 
                board.pt[ptr.pt].stat=EMPTY;
              draw = 1;
            }
          }
          if (maskr & Button2Mask){
            if (ptr.def) {
              if (board.pt[ptr.pt].stat==EMPTY) 
                board.pt[ptr.pt].stat=WH;
              else if (board.pt[ptr.pt].stat==WH) 
                board.pt[ptr.pt].stat=EMPTY;
              draw = 1;
            }
          }

          if (maskr & Button3Mask){
            mode = ROTATE; 
            XSetWMName(theDisplay, theMain, xmode_text[mode]);
          }
        }

        if (ptr.def) drawptr=1;

        /* .. choosing the board .. .. .. .. .. .. .. .. .. .. ..  */

        if (oldmaskr != maskr){
          if (maskr & ShiftMask){
            style = (style +1)%NUMBOARD;
            create_board = 1;
            draw = 0;
            size = 1;
          }
          if (maskr & ControlMask){ 
            size = size%MX_GRID+1;
            if(size==MX_GRID) size =1;
            draw = 0;
            create_board = 1;
          }
        }

        if (create_board) {
          create_board = 0;
          make_board(style);
          if (style == SQUARE) { scale = blocksize*0.9; dimen = 3; }
          if (style == HYPERTETSQ) { scale = blocksize*0.9; dimen = 4; }
          if (style == HYPERTETRA) { scale = blocksize*0.65; dimen = 4; }
          if (style == HYPERSQ) { scale = blocksize*1.0; dimen = 4; }
          if (style == TETRA) { scale = blocksize*0.6; dimen = 3; }
    
          recalcpts(tranm,lengt,scale,dimen);
          ptr.def = 0;
          draw = 1;
        }

      break;
      /*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/ 
      case ROTATE:
        /* .. figure out which dimensions to rotate in depending on mask .. */
        a11=0; a12=2; a21=1; a22=2;
        if (maskr & Button2Mask) {
          if (maskr & Button1Mask) { a11=2; a12=3; a21=1; a22=3; }
          else { a11=0; a12=3; a21=1; a22=3; }
        }
        else if (maskr & Button1Mask) a12=a21;  
  
        rot1 = (xpo-xp)*MOUMULT;
        rot2 = (ypo-yp)*MOUMULT;
        if (xp >lengt-SCRBOR) rot1 = -ROTVEL;
        if (xp <SCRBOR) rot1 = ROTVEL;
        if (yp >lengt-SCRBOR) rot2 = -ROTVEL;
        if (yp <SCRBOR) rot2 = ROTVEL;
        if (xp<lengt && xp>0 && yp<lengt && yp>0) {
          draw = (!(rot1==0&&rot2==0));
          if(rot1!=0) rotate_mat(a11,a12,rot1,tranm); 
          if(rot2!=0) rotate_mat(a21,a22,rot2,tranm); 
        }
        else draw=0;
        if (draw) recalcpts(tranm,lengt,scale,dimen);

        if (maskr & Button3Mask && oldmaskr != maskr) {
          mode = CHOOSE; 
          XSetWMName(theDisplay, theMain, xmode_text[mode]);
        }

        /* .. using stored positions .. .. .. .. .. .. .. .. .. .. */

        if (maskr & ShiftMask) {
          if (maskr & LockMask) equal_mat(tran2,tranm); 
          else {
             /* .. slow rotation back to the saved positions .. */
             notdone = 1;
             equal_mat(tempm,tranm);
             while(notdone){
               notdone = next_mat(tempm, tran2, RETVEL);
               recalcpts(tempm,lengt,scale,dimen);
               drawob(0);
             }
             equal_mat(tranm, tran2);
             recalcpts(tranm,lengt,scale,dimen);
             draw = 1;
          }
        }
        if (maskr & ControlMask) {
          if (maskr & LockMask) equal_mat(tran1,tranm); 
          else {
             /* .. slow rotation back to the saved positions .. */
             notdone = 1;
             equal_mat(tempm,tranm);
             while(notdone){
               notdone = next_mat(tempm, tran1, RETVEL);
               recalcpts(tempm,lengt,scale,dimen);
               drawob(0);
             }
             equal_mat(tranm, tran1);
             recalcpts(tranm,lengt,scale,dimen);
             draw = 1;
          }
        }
      break;
      /*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/ 
    }

    if (draw) drawob(drawptr);
    draw = 0;
    ypo=yp;
    xpo=xp;
    oldmaskr = maskr; 

    /* .. wait for something to happen .. */
    XNextEvent(theDisplay, &win_event);
    /* .. I really should look through the events but since I already 
          have the code for this I leave it as is .. */
    XQueryPointer(theDisplay, theMain,&junkrr,&junkcr,
      &moux,&mouy,&xp,&yp,&maskr);
  }

  XCloseDisplay(theDisplay);
  exit(0);
}

/*---------------------------------------------------------------------*/

recalcpts(orient,lengt,scale,dimen)
matrix orient;
int lengt;
double scale;
int dimen;
{
  int i,j,k,h,c;
  float tmp,z=1.0;
  
/* compute board points */

  for (i=0;i<board.numpt;i++){
    tmp = 0;
    for (j=0;j<dimen;j++)
      tmp += orient[3][j]*board.pt[i].coord[j]; 
    board.pt[i].scrcoord[3] = (int)((tmp/scale+1)*DEPTH*D4COL);
    tmp = 0;
    for (j=0;j<dimen;j++)
      tmp += orient[2][j]*board.pt[i].coord[j]; 
    board.pt[i].scrcoord[2] = (int)((tmp/scale+1)*DEPTH*DCOL);
    z = pow(1.2,tmp/scale);
    tmp = 0;
    for (j=0;j<dimen;j++)
      tmp += orient[0][j]*board.pt[i].coord[j]; 
    board.pt[i].scrcoord[0] = (int)((tmp/scale*z + 1)*lengt/2);
    tmp = 0;
    for (j=0;j<dimen;j++)
      tmp += orient[1][j]*board.pt[i].coord[j]; 
    board.pt[i].scrcoord[1] = (int)((tmp/scale*z + 1)*lengt/2);
  }

}

/*---------------------------------------------------------------------*/

drawob(drawptr)
int drawptr;
{
  int i,j,k,h,hh,c;
  float tmp,z=1.0;
  
  XFillRectangle(theDisplay,lPixmap,newGC[BLANK_COL],0,0,lengt,lengt);
 
/* Draw the board */

  for (i=0;i<board.numedge;i++){
    hh=(board.pt[board.con[i][0]].scrcoord[3] + 
       board.pt[board.con[i][1]].scrcoord[3]) /(DEPTH*4);
    h=(board.pt[board.con[i][0]].scrcoord[2] + 
       board.pt[board.con[i][1]].scrcoord[2]) /(DEPTH*4);
    XDrawLine(theDisplay,lPixmap,newGC[depthcol[hh][h]], 
      board.pt[board.con[i][0]].scrcoord[0], board.pt[board.con[i][0]].scrcoord[1], 
      board.pt[board.con[i][1]].scrcoord[0], board.pt[board.con[i][1]].scrcoord[1]);
  }

/* Draw the stones */

  for (i=0;i<board.numpt;i++){
    c=50;
    if (board.pt[i].stat==BL) c = BL_COL;
    if (board.pt[i].stat==WH) c = WH_COL;
    if (c!=50){
      XDrawArc(theDisplay,lPixmap,newGC[c], 
        board.pt[i].scrcoord[0]-PTRS-1, board.pt[i].scrcoord[1]-PTRS-1, 
        PTRS*2+2,PTRS*2+2,0,23040);
      if (c == WH_COL) /* for the poor sods without colour */
        XDrawArc(theDisplay,lPixmap,newGC[c], 
          board.pt[i].scrcoord[0]-PTRS+3, board.pt[i].scrcoord[1]-PTRS+3, 
          PTRS*2-6,PTRS*2-6,2240,2880);
    }
  }

/* Draw the pointer */

  if (drawptr){
    XFillArc(theDisplay,lPixmap,newGC[1], 
      board.pt[ptr.pt].scrcoord[0]-PTRS, board.pt[ptr.pt].scrcoord[1]-PTRS, 
      PTRS*2,PTRS*2,0,23040);
    XDrawArc(theDisplay,lPixmap,newGC[BLANK_COL], 
      board.pt[ptr.pt].scrcoord[0]-PTRS+3, board.pt[ptr.pt].scrcoord[1]-PTRS+3, 
      PTRS*2-6,PTRS*2-6,2240,2880);
  }

  XCopyArea(theDisplay,lPixmap,theMain,pixGC,0,0,lengt,lengt,0,0);
}

/*---------------------------------------------------------------------*/

equal_mat(result,data)
matrix result,data;
{
  int i,j;

  for (i=0;i<4;i++)
    for (j=0;j<4;j++)
      result[i][j] = data[i][j];
}

/*---------------------------------------------------------------------*/

rotate_mat(coord1,coord2,angle,tranm)
int coord1,coord2;
int angle;
matrix tranm;
{
  int i,j,k;
  matrix rot,tranmn;

   for (i=0;i<4;i++)
     for (j=0;j<4;j++)
       if (i==j) rot[i][j] = 1.0;
       else rot[i][j] = 0.0;
   rot[coord1][coord2] = -sin((double)(angle)*DtoR);
   rot[coord2][coord1] = sin((double)(angle)*DtoR);
   rot[coord1][coord1] = cos((double)(angle)*DtoR);
   rot[coord2][coord2] = cos((double)(angle)*DtoR);

   for (i=0;i<4;i++)
     for (j=0;j<4;j++){
       tranmn[i][j] = 0.0; 
       for (k=0;k<4;k++)
         tranmn[i][j] += rot[i][k]*tranm[k][j];
     }
   equal_mat(tranm,tranmn);
}

/*---------------------------------------------------------------------*/

orthom(result)
matrix result;
{
  int i,j,k;
  float dot;

  for (i=0;i<4;i++){
    dot=0;
    for (k=0;k<4;k++)
      dot += result[i][k]*result[i][k];
    for (k=0;k<4;k++)
      if (dot) result[i][k] = result[i][k]/sqrt(dot);

    for (j=i+1;j<4;j++){
      dot=0;
      for (k=0;k<4;k++)
        dot += result[i][k]*result[j][k];
      for (k=0;k<4;k++)
        result[j][k] = result[j][k]-dot*result[i][k];
    }
  }
}

/*---------------------------------------------------------------------*/

int next_mat(result,data,var)
matrix result,data;
float var;
{
  int i,j,flag=0;
  matrix temp;
  float t,v;

  t = 1.0;
  equal_mat(temp,result); 
  v = 0.0;
  for (i=0;i<4;i++)
    for (j=0;j<4;j++)
      v += (temp[i][j]-data[i][j])*(temp[i][j]-data[i][j]);
  while (v > var){
    flag = 1;
    t = t/2;
    for (i=0;i<4;i++)
      for (j=0;j<4;j++)
        temp[i][j] = t*data[i][j]+(1.0-t)*result[i][j];
    orthom(temp);
    v = 0.0;
    for (i=0;i<4;i++)
      for (j=0;j<4;j++)
        v += (temp[i][j]-result[i][j])*(temp[i][j]-result[i][j]);
  }

  equal_mat(result,temp); 
  return(flag);
}

/*---------------------------------------------------------------------*/

#define Acon       0.292893218
#define Bcon       0.478072579 
#define R3         1.732050808

int    grid[2*MX_GRID+1][2*MX_GRID+1][2*MX_GRID][2*MX_GRID+1][2];

void make_board(style)
int style;
{
  float  max[4],min[4],cent[4];
  int    i,j,k,l,m,p,a,b,c,d,e,mx,mn,stat;

  /* .. clear the board .. */
 
  for (i=0;i<2*size+1;i++)
    for (j=0;j<2*size+1;j++)
      for (k=0;k<2*size+1;k++)
        for (l=0;l<2*size+1;l++){
          grid[i][j][k][l][0] = 0;
          grid[i][j][k][l][1] = BLANK;
        }

  if (style==TETRA) {

    /* .. first get rid of 'corners' .. */

    for (i=0;i<size-1;i++)
      for (j=0;j<size-1-i;j++)
        for (k=0;k<size-1-j-i;k++){
          grid[i][size-j][k][0][1] = NUSED;
          grid[2*size-i][size-j][k][0][1] = NUSED;
          grid[i][j][size-1-k][0][1] = NUSED;
          grid[2*size-i][j][size-1-k][0][1] = NUSED;
        }  

    /* .. grow the coordinates of each vertex .. */

    grid[0][0][0][0][1] = EMPTY;
    board.numpt = 0;
    board.numedge = 0;
    givexyzw(board.numpt,0.0,0.0,0.0,0.0);
    for (k=0;k<size;k++)
      for (j=0;j<size+1;j++)
        for (i=0;i<2*size+1;i++){
          p = grid[i][j][k][0][0]; 
          if (grid[i][j][k][0][1] != NUSED){
          if ((i+j+k)%2){
            givecoord(p,i-1,j,k,-Bcon,R3*Bcon,-Acon);
            givecoord(p,i+1,j,k,Bcon*2,0.0,-Acon);
            givecoord(p,i,j-1,k,-Bcon,-R3*Bcon,-Acon);
            givecoord(p,i,j,k+1,0.0,0.0,1.0);
          }
          else{ 
            givecoord(p,i-1,j,k,-Bcon*2,0.0,Acon);
            givecoord(p,i+1,j,k,Bcon,-R3*Bcon,Acon);
            givecoord(p,i,j+1,k,Bcon,R3*Bcon,Acon);
            givecoord(p,i,j,k-1,0.0,0.0,-1.0);
          }
          }
        }
  } else if (style==SQUARE){

  /* .. first get rid of the 'holes' .. */

    for (i=0;i<2*size+1;i++){
      if (i%2) l=0;
      else l=1;
      for (j=l;j<2*size+1;j+=2)
        for (k=l;k<2*size+1;k+=2)
          grid[i][j][k][0][1] = NUSED;
    }

  /* .. first get rid of the unecessary vertices with 2 neighbours .. */

    for (i=2;i<2*size;i+=2)
      for (j=0;j<2*size+1;j+=2*size)
        for (k=0;k<2*size+1;k+=2*size)
          grid[i][j][k][0][1] = NUSED;
     
  /* .. give coordinates and connections of board .. */

    board.numpt=0;
    for (i=0;i<2*size+1;i++)
      for (j=0;j<2*size+1;j++)
        for (k=0;k<2*size+1;k++)
          if (grid[i][j][k][0][1]!= NUSED){
            grid[i][j][k][0][0] = board.numpt;
            givexyzw(board.numpt,(float)i,(float)j,(float)k,0.0);
          }
   
    board.numedge = 0;
    for (i=0;i<2*size+1;i++)
      for (j=0;j<2*size+1;j++)
        for (k=0;k<2*size+1;k++)
          if (grid[i][j][k][0][1] != NUSED){
            if (i+1<2*size+1)
              if (grid[i+1][j][k][0][1] != NUSED)
                giveedge(grid[i][j][k][0][0],grid[i+1][j][k][0][0]);
            if (j+1<2*size+1)
              if (grid[i][j+1][k][0][1] != NUSED)
                giveedge(grid[i][j][k][0][0],grid[i][j+1][k][0][0]);
            if (k+1<2*size+1)
              if (grid[i][j][k+1][0][1] != NUSED)
                giveedge(grid[i][j][k][0][0],grid[i][j][k+1][0][0]);
          }
  } else if (style==HYPERSQ){

  /* .. first get rid of the 'holes' .. */

    for (i=0;i<2*size+1;i++)
      for (j=0;j<2*size+1;j++){
        p = i%2+(j%2)*2;
        if (p==0)
          for (k=1;k<2*size+1;k+=2)
            for (l=1;l<2*size+1;l+=2)
              grid[i][j][k][l][1] = NUSED;
        if (p==1)
          for (k=0;k<2*size+1;k+=2)
            for (l=0;l<2*size+1;l++)
              grid[i][j][k][l][1] = NUSED;
        if (p==2)
          for (k=0;k<2*size+1;k++)
            for (l=0;l<2*size+1;l+=2)
              grid[i][j][k][l][1] = NUSED;
        if (p==3)
          for (k=0;k<2*size+1;k++)
            for (l=0;l<2*size+1;l++)
              if (!((k%2)*(l%2))) grid[i][j][k][l][1] = NUSED;
      }

  /* .. first get rid of the unecessary vertices with 2 neighbours .. */

    for (i=2;i<2*size;i+=2)
      for (j=2;j<2*size;j+=2)
        for (k=0;k<2*size+1;k+=2*size)
          for (l=0;l<2*size+1;l+=2*size)
            grid[i][j][k][l][1] = NUSED;
     
  /* .. give coordinates and connections of board .. */

    board.numpt=0;
    for (i=0;i<2*size+1;i++)
      for (j=0;j<2*size+1;j++)
        for (k=0;k<2*size+1;k++)
          for (l=0;l<2*size+1;l++)
            if (grid[i][j][k][l][1] != NUSED){
              grid[i][j][k][l][0] = board.numpt;
              givexyzw(board.numpt,(float)i,(float)j,(float)k,(float)l);
            }
   
    board.numedge = 0;
    for (i=0;i<2*size+1;i++)
      for (j=0;j<2*size+1;j++)
        for (k=0;k<2*size+1;k++)
          for (l=0;l<2*size+1;l++)
            if (grid[i][j][k][l][1] != NUSED){
              if (i+1<2*size+1)
                if (grid[i+1][j][k][l][1] != NUSED)
                  giveedge(grid[i][j][k][l][0],grid[i+1][j][k][l][0]);
              if (j+1<2*size+1)
                if (grid[i][j+1][k][l][1] != NUSED)
                  giveedge(grid[i][j][k][l][0],grid[i][j+1][k][l][0]);
              if (k+1<2*size+1)
                if (grid[i][j][k+1][l][1] != NUSED)
                  giveedge(grid[i][j][k][l][0],grid[i][j][k+1][l][0]);
              if (l+1<2*size+1)
                if (grid[i][j][k][l+1][1] != NUSED)
                  giveedge(grid[i][j][k][l][0],grid[i][j][k][l+1][0]);
          }
  } else if (style==HYPERTETRA||style==HYPERTETSQ){

  /* .. first get the general design .. */
  /* .. I think there is a better way to do this but this works .. */

  /* .. clear the board .. */
 
  for (i=0;i<2*size+1;i++)
    for (j=0;j<2*size+1;j++)
      for (k=0;k<2*size+1;k++)
        for (l=0;l<2*size+1;l++){
          grid[i][j][k][l][1] = NUSED;
        }

    for (i=0;i<=size;i++)
      for (j=0;j<=size;j++){
        a = abs(i-j);
        b = size;
        if (i>j) { mx = i; mn = j;}
        else { mx = j; mn = i;}
        c = b - mn;
        d = b;
        e = mx+1;
        if (i==size || j==size){
          if (j==size||j==0){ b=size;  c=a;  d=0;  e=size; }
          else {  d=size-1;  b=d;  e=d; }
        }

        /* .. make a pseudo hex with a,b,c,d,e .. */       
        for (k=c;k<=b;k++){
          for (l=0;l<2*k+1;l++){
            grid[i][j][l+size-k][a][1]=0;
            if(!(l%2)){
              if(!(i==size&&k==b)) grid[i][j][l+size-k][a+1][1]=0;
            }
            else if(k==c && i<j) grid[i][j][l+size-k][a-1][1]=0;
          } 
          a+=2;
        }
        if (j!=0&&j!=size&&i==0){
          grid[i][j][size-b][a-2][1]=NUSED;
          grid[i][j][size+b][a-2][1]=NUSED;
        }
        
        for (k=d;k>=e;k--){
          for (l=0;l<2*k+1;l++){
            grid[i][j][l+size-k][a][1]=BLANK;
            if(!(l%2)) grid[i][j][l+size-k][a-1][1]=BLANK;
            else if(k==e&&i<j) grid[i][j][l+size-k][a+1][1]=BLANK;
          } 
          a+=2;
        }
      }

  /* .. give coordinates and connections of board .. */

    board.numpt=0;
    for (i=0;i<2*size+1;i++)
      for (j=0;j<2*size+1;j++)
        for (k=0;k<2*size+1;k++)
          for (l=0;l<2*size+1;l++)
            if (grid[i][j][k][l][1] != NUSED){
              grid[i][j][k][l][0] = board.numpt;
              board.pt[board.numpt].stat = 0;
              board.numpt++;
            }

    givexyzw2(0,(float)0.0,(float)0.0,(float)0.0,(float)0.0);
    grid[0][0][0][0][1] = EMPTY;

    board.numedge = 0;
    for (i=0;i<2*size+1;i++)
      for (j=0;j<2*size+1;j++)
        for (k=0;k<2*size+1;k++)
          for (l=0;l<2*size+1;l++)
            if (grid[i][j][k][l][1] != NUSED){
              p=grid[i][j][k][l][0];
              stat=grid[i][j][k][l][1];
              if ((i+j+l)%2==0){ /* .. a or b .. */
                if ((l/2+k+(i+j)/2)%2==0){ /* .. a .. */
                  givecoord2(p,stat,i-1,j,k,l,0.0,0.0,1.0,0.0);
                  givecoord2(p,stat,i,j,k,l+1,Bcon*2,0.0,-Acon,0.0);
                  givecoord2(p,stat,i,j,k+1,l,-Bcon,-R3*Bcon,-Acon,0.0);
                  givecoord2(p,stat,i,j,k-1,l,-Bcon,R3*Bcon,-Acon,0.0);
                } else{  /* .. b .. */ 
                  givecoord2(p,stat,i,j,k-1,l,Bcon,R3*Bcon,Acon,0.0);
                  givecoord2(p,stat,i,j,k+1,l,Bcon,-R3*Bcon,Acon,0.0);
                  givecoord2(p,stat,i,j+1,k,l,-Bcon,0.0,-Acon,-R3*Bcon);
                  givecoord2(p,stat,i,j,k,l-1,-Bcon,0.0,-Acon,R3*Bcon);
                }
              } else{ /* .. c .. */
                  givecoord2(p,stat,i+1,j,k,l,0.0,0.0,-1.0,0.0);
                  givecoord2(p,stat,i,j,k,l-1,-Bcon*2,0.0,Acon,0.0);
                  givecoord2(p,stat,i,j-1,k,l,Bcon,0.0,Acon,R3*Bcon);
                  givecoord2(p,stat,i,j,k,l+1,Bcon,0.0,Acon,-R3*Bcon);
              }
          }
    if (style == HYPERTETSQ){
      for (i=0;i<2*size+1;i++)
        for (j=0;j<2*size+1;j++)
          for (k=0;k<2*size+1;k++)
            for (l=0;l<2*size+1;l++)
              if (grid[i][j][k][l][1] != NUSED){
                board.pt[grid[i][j][k][l][0]].coord[0] = (float)i;
                board.pt[grid[i][j][k][l][0]].coord[1] = (float)j;
                board.pt[grid[i][j][k][l][0]].coord[2] = (float)k;
                board.pt[grid[i][j][k][l][0]].coord[3] = (float)l;
              }
    }
  }

  /* .. get centre of mass .. */

  for (i=0;i<4;i++){
    max[i] = 0;
    min[i] = 0;
  }
  for(i=0;i<board.numpt;i++)
    for(j=0;j<4;j++) {
      if (board.pt[i].coord[j] > max[j]) max[j]=board.pt[i].coord[j];
      if (board.pt[i].coord[j] < min[j]) min[j]=board.pt[i].coord[j];
    } 

  blocksize = 0.0;  
  for(i=0;i<4;i++) {
    if (max[i]-min[i]>blocksize) blocksize = max[i]-min[i];
    cent[i] = (min[i]+max[i])/2;
  }
  for(i=0;i<board.numpt;i++){
     board.pt[i].coord[0] -= cent[0];
     board.pt[i].coord[1] -= cent[1];
     board.pt[i].coord[2] -= cent[2];
     board.pt[i].coord[3] -= cent[3];
  }
}

/*---------------------------------------------------------------------*/

givecoord(p,i,j,k,si,sj,sk)
int p,i,j,k;
float si,sj,sk;
{
  if ((i>=0)&&(i<2*size+1)&&
      (j>=0)&&(j<size+1)&& 
      (k>=0)&&(k<size)) 
    if (grid[i][j][k][0][1]==BLANK) {
      grid[i][j][k][0][0] = board.numpt;
      grid[i][j][k][0][1] = EMPTY;
      givexyzw(board.numpt,board.pt[p].coord[0]+si,board.pt[p].coord[1]+sj,
        board.pt[p].coord[2]+sk,0.0);
      giveedge(p,grid[i][j][k][0][0]);
    }
    else if (p<grid[i][j][k][0][0])
      if (grid[i][j][k][0][1]==EMPTY) 
        giveedge(p,grid[i][j][k][0][0]);
}
   
/*---------------------------------------------------------------------*/

givecoord2(p,stat,i,j,k,l,si,sj,sk,sl)
int p,stat,i,j,k,l;
float si,sj,sk,sl;
{
  if ((i>=0)&&(i<2*size+1)&&
      (j>=0)&&(j<2*size+1)&& 
      (l>=0)&&(l<2*size+1)&& 
      (k>=0)&&(k<2*size+1)) {
    if (grid[i][j][k][l][1]==BLANK&&stat==EMPTY) {
      grid[i][j][k][l][1] = EMPTY;
      givexyzw2(grid[i][j][k][l][0],board.pt[p].coord[0]+si,board.pt[p].coord[1]+sj,
        board.pt[p].coord[2]+sk,board.pt[p].coord[3]+sl);
    }
    if (grid[i][j][k][l][1]!=NUSED) 
      if (p<grid[i][j][k][l][0])
        giveedge(p,grid[i][j][k][l][0]);
  }
}
   
/*---------------------------------------------------------------------*/

givexyzw2(pt,x,y,z,w)
int pt;
float x,y,z,w;
{
  board.pt[pt].coord[0] = x;
  board.pt[pt].coord[1] = y;
  board.pt[pt].coord[2] = z;
  board.pt[pt].coord[3] = w;
  board.pt[pt].stat = EMPTY;
}

givexyzw(pt,x,y,z,w)
int pt;
float x,y,z,w;
{
  board.pt[pt].coord[0] = x;
  board.pt[pt].coord[1] = y;
  board.pt[pt].coord[2] = z;
  board.pt[pt].coord[3] = w;
  board.numpt++;
  board.pt[pt].stat = EMPTY;
}

giveedge(x,y)
int x,y;
{
  board.con[board.numedge][0] = x;
  board.con[board.numedge][1] = y;
  board.numedge++;
}

/*---------------------------------------------------------------------*/
/*---------------------------------------------------------------------*/

void make_colourmap()
{
  Colormap      default_cmap;
  unsigned long white_pix;
  char colour[8];
  int i,j,a,b,c;

  default_cmap = DefaultColormap(theDisplay,DefaultScreen(theDisplay));
  white_pix = WhitePixel(theDisplay,DefaultScreen(theDisplay));

  /* .. make a ramp? .. */

  ass_colour(BLANK_COL, "#ffffff", default_cmap, white_pix);
  ass_colour(BL_COL, "#008000" , default_cmap, white_pix);
  ass_colour(WH_COL, "#ff0000" , default_cmap, white_pix);

  for (i=0; i<DCOL;i++) {
    for (j=0; j<D4COL;j++) {
      a = (int)(255*((float)(DCOL-i-1)/DCOL));
      b = (int)(255*((float)(DCOL-i-1)/DCOL));
      c = (int)(255*((float)(DCOL-i-1)/DCOL));
      if (j>D4COL/2+1) c = (int)(255*((float)j/D4COL));
      if (j<D4COL/2-1) { 
        a = (int)(255*((float)(D4COL-j)/D4COL)); 
        b = (int)(255*((float)(D4COL-j)/D4COL));
      }
/*      printf("%d,%d->>> %d,%d,%d (#%02x%02x%02x)\n",i,j,a,b,c,a,b,c); */
      sprintf (colour,"#%02x%02x%02x",a,b,c);     
      ass_colour(i*D4COL + j + 3, colour, default_cmap, white_pix);
      depthcol[j][i] = i*D4COL + j + 3;
    }     
  }
}

/*---------------------------------------------------------------------*/

void ass_colour(int i, char *colour, Colormap default_cmap, 
  unsigned long white_pix)
{
  XColor        color;
  XGCValues     gcv;

  /* .. allocating the given color make sure it is OK .. */

  if (XParseColor(theDisplay,default_cmap, colour, &color) == 0 ||
    XAllocColor(theDisplay, default_cmap, &color) == 0) {
    /* use black in case of failure */
    newpixel[i]=BlackPixel(theDisplay,DefaultScreen(theDisplay));
    fprintf(stderr,"colour %s failed \n", colour);
  } else { /* .. colormap cell successfully allocated .. */
      newpixel[i]=color.pixel;
  }

  /* .. allocating a new GC with color in foreground white in the background */

  gcv.font = theFontStruct -> fid ;
  gcv.foreground = newpixel[i] ;
  gcv.background = white_pix ;
  newGC[i] = XCreateGC(theDisplay, lPixmap,
    (GCForeground | GCBackground | GCFont), &gcv);
}

